	const express    = require('express');
	const exec       = require('child_process').exec;		
	

	function prepareClientFolder(clientName, fileName){
		return new Promise((resolve,reject)=>{

			exec('cp -R ' + fileName + ' ' + clientName + '/',(error,stdout,stderr)=>{

				if (error) {
					reject(error);
					return;
				}

				console.log(stdout);
				console.log(stderr);

				resolve(fileName);

			})	
		})


	}


//remove addons from former builds
function backendClean(clientName, fileName){

	return new Promise((resolve,reject)=>{
		const path= process.cwd()+'/' + clientName + '/explorviz-ui-backend/plugins/net/explorviz/';
		exec('rm -rf plugins/*',{cwd:path}, (error, stdout,stderr)=>{
			
			if (error) {
				console.log('backendClean:', error);
				reject(error);
				return;
			}

			console.log(stdout);
			console.log(stderr);

			resolve(fileName);

		})
	})
}

function backendPull(clientName, fileName){

	return new Promise((resolve, reject)=> {

		const path= process.cwd()+'/'+clientName + '/'+ fileName;
		exec('git pull ',{cwd:path} ,(error, stdout, stderr) => {
			
			if (error) {
				console.log('backendPull:', error);
				reject(error);
				return;
			}

			console.log(stdout);
			console.log(stderr);

			resolve();

		}); 
	})

}

function backendInstallAddons(checkedFiles,downloadFiles,clientName){

	return new Promise((resolve, reject)=>{


		checkedPlugins = checkedFiles.filter(function(file){
			return /\bexplorviz-backend-plugin-\w*/.exec(file);
		});

		if(checkedPlugins.length !== 0 ){

			checkedPlugins.forEach((pluginName) => {
				
				const path= process.cwd()+'/'+ pluginName;
							exec('git pull ' + ' && rsync -av . ' + ' ../' + clientName +'/explorviz-ui-backend/plugins/net/explorviz/plugins/ ' + ' --exclude .git',{cwd:path}, (error, stdout, stderr) => { //'cd explorviz-ui-backend/plugins/net/explorviz/plugins/ ' + 
								
								if (error) {
									console.log('backendInstallAddons:', error);
									reject(error);
									return;
								}

								console.log(stdout);
								console.log(stderr);
								
								resolve();

							});

						})
		} else {
			resolve();
		}

	})


}
function backendBuild(checkedFiles, clientName, fileName){

	return new Promise((resolve,reject)=>{

		
		
		const path= process.cwd()+'/'+clientName + '/' + fileName;
		exec('mvn compile war:war',{cwd:path}, (error,stdout,stderr)=> {
			

			if (error) {
				console.log('backendBuild:', error);
				reject(error);
				return;
			}

			console.log(stdout);
			console.log(stderr);

			resolve({zipFileName:'backend.war', path: clientName + '/explorviz-ui-backend/target/explorviz-ui-backend-1.0-SNAPSHOT.war'});


		})

	})


}

module.exports = {
	prepareClientFolder,
	backendClean,
	backendPull,
	backendInstallAddons,
	backendBuild


}